

import java.awt.*;
import java.util.Random;
 
public class PanelCables extends javax.swing.JPanel {
    
    private int longitud;
    private int averiado;
    private int tipoAveria;
    private int paresCorto[]=new int[8];
    private Random rnd = new Random(); // crea la semilla 
    private int propiedades[]=new int[6];
    private int paridad=0;
    private double aux,prop2;
    private Image fondo;
    
    public PanelCables(Practica_Cablemeter ap){
        this.setSize(100,100);
        fondo=ap.getImage("rj45.png"); 
        //inicializacion del buffer de averias
        //se inicializa aqui porque es fijo
        paresCorto[0]=12;
        paresCorto[1]=13;
        paresCorto[2]=36;
        paresCorto[3]=34;
        paresCorto[4]=45;
        paresCorto[5]=58;
        paresCorto[6]=78;
        paresCorto[7]=27;
    }
    
    public void paint(Graphics g) {
        Dimension tamanio = getSize();
        g.drawImage(fondo, 0, 0, tamanio.width, tamanio.height, null);
        this.setOpaque(false);
        super.paint(g);
        this.repaint();
    }
   
    public int[] propiedades(int j){
       
       rnd.setSeed(System.currentTimeMillis()*j);                                   
       longitud=(int)(rnd.nextDouble()*20+4);
       /*
       *numero aleatorio entre 0 y 2
       *para generar si hay averia o no
       *NO averia si <1, Si averia si >=1 
       */
       
       if((int)(rnd.nextDouble()*3)<1){
           averiado=0; // NO averiado
           //Se generan la longitud de los pares
           
           propiedades[0]=averiado;
           propiedades[1]=longitud;//longPares12;
           propiedades[2]=longitud;//longPares36;
           propiedades[3]=longitud;//longPares45;
           propiedades[4]=longitud;//longPares78;
           propiedades[5]=longitud;
           return propiedades;
       }
       else{
           rnd.setSeed((System.currentTimeMillis()*j));
           tipoAveria=(int)(rnd.nextDouble()*15);
       
           
           /*
            tipoAveria € [0,2)--> Cortocircuito lejano mismo par--> averiado=1
            *tipoAveria € [2,4)--> Cortocircuito lejano distinto par--> averiado=2
            *tipoAveria € [4,6)--> Cortocircuito cercano mismo par--> averiado=3
            *tipoAveria € [6,8)--> Cortocircuito cercano distino par--> averiado=4
            *tipoAveria € [8,10)--> Cable en circuito abierto--> averiado=5
            *tipoAveria € [10,12)--> Par en circuito abierto--> averiado=6
            *tipoAveria € [12,14]--> Cambio en las conexiones de los cables--> averiado=7 
            */
           if(tipoAveria<2){
               averiado=1;
               do{
                  rnd.setSeed((System.currentTimeMillis()*j));
                  paridad=(int)((rnd.nextDouble()*8));
               }while(paridad!=0&&paridad!=2&&paridad!=4&&paridad!=6);
               //La paridad indica que cables del mismo par estan en corto   
           }
           else if(tipoAveria>=2&&tipoAveria<4){
               averiado=2;
               do{
                  rnd.setSeed((System.currentTimeMillis()*j));
                  paridad=(int)(rnd.nextDouble()*8); 
               }while(paridad!=1&&paridad!=3&&paridad!=5&&paridad!=7);
               //La paridad indica que cables del mismo par estan en corto
           }
           else if(tipoAveria>=4&&tipoAveria<6){
               averiado=3;
               do{
                  rnd.setSeed((System.currentTimeMillis()*j));
                  paridad=(int)(rnd.nextDouble()*8); 
               }while(paridad!=0&&paridad!=2&&paridad!=4&&paridad!=6);
           }
           else if(tipoAveria>=6&&tipoAveria<8){
               averiado=4;
               do{
                  rnd.setSeed((System.currentTimeMillis()*j));
                  paridad=(int)(rnd.nextDouble()*8); 
               }while(paridad!=1&&paridad!=3&&paridad!=5&&paridad!=7);
           }
           else if(tipoAveria>=8&&tipoAveria<10){
               averiado=5;
               if((int)(rnd.nextDouble()*9)<4){
                    
                    propiedades[3]=1;//indica que el cable abierto lo esta en el extremo cercano
                    //el cable esta en propiedades[2]
                }
                else{
                    propiedades[3]=2;//indica que el cable abierto lo esta en el extremo lejano
                    //el cable esta en propiedades[2]
                }
           }
           else if(tipoAveria>=10&&tipoAveria<12){
               averiado=6;
               do{// Genera el par que va a estar en circuito abierto
                  rnd.setSeed((System.currentTimeMillis()*j));
                  paridad=(int)((rnd.nextDouble()*8));
               }while(paridad!=0&&paridad!=2&&paridad!=4&&paridad!=6);
               
                if((int)(rnd.nextDouble()*9)<3){
                    
                    propiedades[3]=1;//indica que el par que esta abierto lo esta en el extremo cercano
                
                }
                else{
                    propiedades[3]=2;//indica que el par que esta abierto lo esta en el extremo cercano
                }
           }
           else if(tipoAveria>=12&&tipoAveria<14){
               averiado=7;
               do{// Genera el par que va a estar mal conectado
                  rnd.setSeed((System.currentTimeMillis()*j+1));
                  paridad=(int)((rnd.nextDouble()*8));
               }while(paridad!=0&&paridad!=2&&paridad!=4&&paridad!=6);
           }
          
                rnd.setSeed((System.currentTimeMillis()));//semilla para la proxima generacion de un numero aleatorio
                propiedades[0]=averiado;//indica el tipo de averia
                propiedades[1]=paresCorto[paridad];//coge del array un par aleatorio de los que estan en corto
                aux=rnd.nextDouble()*9;
                if((int)aux<5){            //En propiedades[2] va el cable que esta abierto
                                                                //Pero a veces muestra el par como abierto
                    propiedades[2]=(int)(propiedades[1]/10);    //por lo que para que coincidan utilizo el par
                                                                //para seleccionar el cable
                }
                else if(aux>=5){
                    prop2=((double)propiedades[1]/10)+0.01;
                    while(prop2>0.9){
                         prop2=prop2-1;
                     }
                    propiedades[2]=(int)(prop2*10);
                }
               // propiedades[3] ya esta relleno arriba
                propiedades[4]=(longitud/2);//La mitad de la longitud para las averias cercanas
                propiedades[5]=longitud;//Indica la longitud
                return propiedades;
        }
  }


}


